// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([], function() {
return Class.extend({
	bindConfigSelectionListeners: function(target) {

		var self = this;

		$(target).click(function(e) {
			//disable preview button if nothing is selected
			self.togglePreviewButton();

			var row = self.getContainingRow(e.target);

			//we need to do this so that rowClass
			//does not include 'selected'
			var rowClass;
			var isSelected = row.hasClass('selected');
			row.removeClass('selected');
			rowClass = row.attr('class');

			var previewRow = $('#PreviewRegion tr.' + rowClass);

			//example row class: "NAMENODE-foo"
			//example section head class: "NAMENODE"
			previewSectionHead = $('#PreviewRegion tr.' + rowClass.split('-')[0]);

			if (isSelected) {
				previewRow.remove();
				//If there are no configs in that section
				if(!previewSectionHead.next().hasClass('config')) {
					previewSectionHead.addClass('hidden');
				}
			} else {
				var newRow = $('<tr />', {
					'class': rowClass + " config"
				})
					.append(row.find('.param').clone())
					.append(row.find('.value.old:first').clone())
					.append(row.find('.description').clone());
			
				$(row).addClass('selected');

				//insert at the end of section OR
				//insert at end of table if no
				//sections exist
				var last = previewSectionHead;
				if (previewSectionHead.length > 0) {
					while (last.next().hasClass('config')) {
						last = last.next();
					}
					newRow.insertAfter(last);
					previewSectionHead.removeClass('hidden');
				} else {
					$('#PreviewRegion tbody').append(newRow);
				}
			}
		});
	},

	getContainingRow: function(target) {
		return $(target).parents('tr:first');
	},

	togglePreviewButton: function() {
		if ($('.revert:checked').length > 0) {
			$('.togglePreview').removeAttr("disabled");
		} else {
			//gets around race condition
			$('.togglePreview').attr("disabled", true);
		}
	},

	init: function() {
		//disable preview button by if nothing is selected
		this.togglePreviewButton();
		this.bindConfigSelectionListeners('.revert');
		$('.togglePreview').click(function(e) {
			$('#DiffRegion').toggleClass('hidden');
			$('#PreviewRegion').toggleClass('hidden');
		});

		var self = this;

		//Highlights selected rows on page load
		//when user hits the back button.
		$('.revert').each(function (k, v) {
			if ($(v).is(':checked')) {
				self.getContainingRow(v).addClass('selected');
			}
		});
	}
});
});
